# -*- coding: iso-8859-1 -*-
#
# $Id: BaseAnswer.py,v 1.7 2005/10/21 13:46:13 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from AccessControl import ClassSecurityInfo

from Products.Archetypes.public import BaseSchema, Schema, BooleanField, StringField, TextField, SelectionWidget, TextAreaWidget, RichWidget, BaseContent, registerType
from Products.Archetypes.Widget import TypesWidget, IntegerWidget, BooleanWidget, StringWidget

from Products.LlsMultipleChoice.config import PROJECTNAME, SKINS_DIR, \
    QUESTION_DIR, QUESTION_TYPES, ANSWER_DIR, \
    ANSWER_TYPES, GLOBALS, PERMISSION_INTERROGATOR, \
    PERMISSION_STUDENT, I18N_DOMAIN
from Products.LlsMultipleChoice.tools import log, hideIdField

class BaseAnswer(BaseContent):
    """ A basic answer. The actual text has to be supplied by the candidate.
    """
    
    # This prevents the Questions from showing up as a portal content type
    global_allow = False

    # See comments in 'AbstractQuestionContainer' for an explanation
    # of the function of a schema, therein defined properties (fields) and 
    # internationalization of the widgets
    schema = BaseSchema + Schema((
            StringField('title',
                widget=StringWidget(macro='empty_widget'),
            )
        ),
    )
    
    # Use a custom page template for viewing.
    actions = (
        {
            'id': 'view',
            'action': 'string:${object_url}/baseanswer_view',
            'permissions': (PERMISSION_INTERROGATOR,),
        },
    )
    meta_type = portal_type = archetype_name = 'Base Answer'
    content_icon = 'Answer.png'
    

# Register this type in Zope
try:
    registerType(BaseAnswer)
    log('Worked: registerType(BaseAnswer)\n')
except Exception, e:
    log('Failed: registerType(BaseAnswer): ' + unicode(e) + '\n')
    raise e
