# -*- coding: iso-8859-1 -*-
#
# $Id: Install.py,v 1.11 2005/05/20 10:11:15 mxp Exp $
#
# Copyright  2004 Otto-von-Guericke-Universitt Magdeburg
#
# This file is part of LlsMultipleChoice.
#
# LlsMultipleChoice is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LlsMultipleChoice is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LlsMultipleChoice; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

""" The install script for this Product. I'm not sure how it's 
    supposed to work but at least it's working if this file 
    is called 'Install.py', contains a function 'install(self)' 
    and is located in a directory called 'Extensions'.
"""

from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from StringIO import StringIO

from Products.LlsMultipleChoice.config import PROJECTNAME, SKINS_DIR, \
    QUESTION_DIR, QUESTION_TYPES, ANSWER_DIR, \
    ANSWER_TYPES, GLOBALS, PERMISSION_INTERROGATOR, \
    PERMISSION_STUDENT
from Products.LlsMultipleChoice.MultipleChoiceTool import MultipleChoiceTool
from Products.LlsMultipleChoice.tools import log


#~ def addParsers(self):
    #~ """
    #~ helper methods to set up a few parsers
    #~ """
    #~ bibparser = BibtexParser('bibtex', '')
    #~ self._setObject('bibtex', bibparser)
    

#~ def addRenderers(self):
    #~ """
    #~ helper methods to set up a few parsers
    #~ """
    #~ bibrenderer = BibtexRenderer('bibtex', '')
    #~ self._setObject('bibtex', bibrenderer)
    

def installTool(self, out):
    """
    adds the multiple choice tool to the portal root folder
    """
    if hasattr(self, MultipleChoiceTool.id):
        # Remove previous versions of the tool.
        self.manage_delObjects([MultipleChoiceTool.id])
        out.write('Deleting old tool; make sure you repeat customizations.\n')
    addTool = self.manage_addProduct[PROJECTNAME].manage_addTool
    addTool(MultipleChoiceTool.meta_type, None)
    out.write('Added the multiple choice tool to the portal root folder.\n')
    multipleChoiceTool = getToolByName(self, MultipleChoiceTool.id)
    acttool = getToolByName(self, 'portal_actions')
    acttool.addActionProvider(MultipleChoiceTool.id)
    out.write('Registered the multiple choice tool as an action provider.\n')

##     ref_types = ['ArticleReference',
##                  'BookReference',
##                  'WebpublishedReference',
##                  ]
    
    prep_server = ['None',
                   'arXiv',
                   'CogPrints']
    
    multipleChoiceTool.manage_changeProperties({
##        'reference_types':ref_types,
        'preprint_servers':prep_server,
        },
        )
    out.write('Set default properties at the multiple choice tool.\n')

    # add default parsers and renderers
    # addParsers(multipleChoiceTool.Parsers)
    # addRenderers(multipleChoiceTool.Renderers)
    out.write('Added default parsers and renderers to the multiple ' \
        'choice tool.\n')
        

def install(self):
    """ Installs the Product in Plone. """
    out = StringIO()
    try:
        # This will go into the install protocol
        out.write("QUESTION_TYPES = " + unicode(QUESTION_TYPES) + "\n")
        out.write("ANSWER_TYPES = " + unicode(ANSWER_TYPES) + "\n")
        
        # Call Archetypes' install functions
        installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)
        install_subskin(self, out, GLOBALS)
        
        #Install the multiple choice tool
        #~ installTool(self, out)
        
        out.write("Successfully installed %s." % PROJECTNAME)
    except Exception, e:
        log("install() failed: " + unicode(e) + "\n")
        out.write("Failed to install %s." % PROJECTNAME)
    return out.getvalue()
